From ad5b8afd9b5a3a03d8423b22d5006d8446b4ada4 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 23 2020 03:31:49 +0000
Subject: [PATCH 38/2232] Add exhaustive coverage of signature kinds


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 3ae732a..168261d 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -1,6 +1,115 @@
+use cxx::{CxxString, UniquePtr};
+
 #[cxx::bridge(namespace = tests)]
 pub mod ffi {
+    struct Shared {
+        z: usize,
+    }
+
     extern "C" {
         include!("tests/ffi/tests.h");
+
+        type C;
+
+        fn c_return_primitive() -> usize;
+        fn c_return_shared() -> Shared;
+        //TODO fn c_return_box() -> Box<R>;
+        fn c_return_unique_ptr() -> UniquePtr<C>;
+        fn c_return_ref(shared: &Shared) -> &usize;
+        fn c_return_str(shared: &Shared) -> &str;
+        fn c_return_rust_string() -> String;
+        fn c_return_unique_ptr_string() -> UniquePtr<CxxString>;
+
+        fn c_take_primitive(n: usize);
+        fn c_take_shared(shared: Shared);
+        fn c_take_box(r: Box<R>);
+        fn c_take_unique_ptr(c: UniquePtr<C>);
+        //TODO fn c_take_ref_r(r: &R);
+        fn c_take_ref_c(c: &C);
+        fn c_take_str(s: &str);
+        fn c_take_rust_string(s: String);
+        fn c_take_unique_ptr_string(s: UniquePtr<CxxString>);
+    }
+
+    extern "Rust" {
+        type R;
+
+        fn r_return_primitive() -> usize;
+        fn r_return_shared() -> Shared;
+        //TODO fn r_return_box() -> Box<R>;
+        //TODO fn r_return_unique_ptr() -> UniquePtr<C>;
+        fn r_return_ref(shared: &Shared) -> &usize;
+        fn r_return_str(shared: &Shared) -> &str;
+        fn r_return_rust_string() -> String;
+        //TODO fn r_return_unique_ptr_string() -> UniquePtr<CxxString>;
+
+        fn r_take_primitive(n: usize);
+        fn r_take_shared(shared: Shared);
+        fn r_take_box(r: Box<R>);
+        fn r_take_unique_ptr(c: UniquePtr<C>);
+        fn r_take_ref_r(r: &R);
+        fn r_take_ref_c(c: &C);
+        fn r_take_str(s: &str);
+        fn r_take_rust_string(s: String);
+        fn r_take_unique_ptr_string(s: UniquePtr<CxxString>);
     }
 }
+
+type R = ();
+
+fn r_return_primitive() -> usize {
+    2020
+}
+
+fn r_return_shared() -> ffi::Shared {
+    ffi::Shared { z: 2020 }
+}
+
+fn r_return_ref(shared: &ffi::Shared) -> &usize {
+    &shared.z
+}
+
+fn r_return_str(shared: &ffi::Shared) -> &str {
+    let _ = shared;
+    "2020"
+}
+
+fn r_return_rust_string() -> String {
+    "2020".to_owned()
+}
+
+fn r_take_primitive(n: usize) {
+    let _ = n;
+}
+
+fn r_take_shared(shared: ffi::Shared) {
+    let _ = shared;
+}
+
+fn r_take_box(r: Box<R>) {
+    let _ = r;
+}
+
+fn r_take_unique_ptr(c: UniquePtr<ffi::C>) {
+    let _ = c;
+}
+
+fn r_take_ref_r(r: &R) {
+    let _ = r;
+}
+
+fn r_take_ref_c(c: &ffi::C) {
+    let _ = c;
+}
+
+fn r_take_str(s: &str) {
+    let _ = s;
+}
+
+fn r_take_rust_string(s: String) {
+    let _ = s;
+}
+
+fn r_take_unique_ptr_string(s: UniquePtr<CxxString>) {
+    let _ = s;
+}
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 6996d77..ecfafd0 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -3,4 +3,71 @@
 
 namespace tests {
 
+C::C(size_t n) : n(n) {}
+
+size_t c_return_primitive() {
+  return 2020;
+}
+
+Shared c_return_shared() {
+  return Shared{2020};
+}
+
+std::unique_ptr<C> c_return_unique_ptr() {
+  return std::unique_ptr<C>(new C{2020});
+}
+
+const size_t &c_return_ref(const Shared &shared) {
+  return shared.z;
+}
+
+cxxbridge::RustStr c_return_str(const Shared &shared) {
+  (void)shared;
+  return "2020";
+}
+
+cxxbridge::RustString c_return_rust_string() {
+  return "2020";
+}
+
+std::unique_ptr<std::string> c_return_unique_ptr_string() {
+  return std::unique_ptr<std::string>(new std::string("2020"));
+}
+
+void c_take_primitive(size_t n) {
+  (void)n;
+}
+
+void c_take_shared(Shared shared) {
+  (void)shared;
+}
+
+void c_take_box(cxxbridge::RustBox<R> r) {
+  (void)r;
+}
+
+void c_take_unique_ptr(std::unique_ptr<C> c) {
+  (void)c;
+}
+
+void c_take_ref_r(const R &r) {
+  (void)r;
+}
+
+void c_take_ref_c(const C &c) {
+  (void)c;
+}
+
+void c_take_str(cxxbridge::RustStr s) {
+  (void)s;
+}
+
+void c_take_rust_string(cxxbridge::RustString s) {
+  (void)s;
+}
+
+void c_take_unique_ptr_string(std::unique_ptr<std::string> s) {
+  (void)s;
+}
+
 } // namespace tests
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 61f11d5..8510946 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -1,6 +1,38 @@
 #pragma once
 #include "include/cxxbridge.h"
+#include <memory>
+#include <string>
 
 namespace tests {
 
+struct R;
+struct Shared;
+
+class C {
+public:
+  C(size_t n);
+
+private:
+  size_t n;
+};
+
+size_t c_return_primitive();
+Shared c_return_shared();
+cxxbridge::RustBox<R> c_return_box();
+std::unique_ptr<C> c_return_unique_ptr();
+const size_t &c_return_ref(const Shared &shared);
+cxxbridge::RustStr c_return_str(const Shared &shared);
+cxxbridge::RustString c_return_rust_string();
+std::unique_ptr<std::string> c_return_unique_ptr_string();
+
+void c_take_primitive(size_t n);
+void c_take_shared(Shared shared);
+void c_take_box(cxxbridge::RustBox<R> r);
+void c_take_unique_ptr(std::unique_ptr<C> c);
+void c_take_ref_r(const R &r);
+void c_take_ref_c(const C &c);
+void c_take_str(cxxbridge::RustStr s);
+void c_take_rust_string(cxxbridge::RustString s);
+void c_take_unique_ptr_string(std::unique_ptr<std::string> s);
+
 } // namespace tests

